use std::sync::{Arc, Mutex, mpsc};
use serde::{Deserialize, Serialize};
use serde_json;

static mut SUBSCRIPTIONS: Option<Arc<Mutex<Vec<mpsc::Sender<Event>>>>> = None;

#[derive(Clone, Serialize, Deserialize)]
pub struct Event{
    pub data: serde_json::Value,
}

pub fn init() {
    unsafe {
        SUBSCRIPTIONS = Some(Arc::new(Mutex::new(Vec::new())));
    }
}

pub fn subscribe() -> mpsc::Receiver<Event> {
    let (rx, tx) = mpsc::channel();
    unsafe { SUBSCRIPTIONS.as_ref().unwrap().lock().unwrap().push(rx); }
    tx
}

pub fn unsubscribe(rx: mpsc::Receiver<Event>) {
    // TODO implement unsubscribe
}

pub fn notify(event: Event) {
    for sender in unsafe { SUBSCRIPTIONS.as_ref().unwrap().lock().unwrap().clone() } {
        sender.send(event.clone());
    }
}


